import { Request, Response } from 'express';
import { Mails } from '../entities/mails';
import connection from '../connections/mysqlConn';
import nodemailer from 'nodemailer';

export const create = async (req: Request, res: Response) => {
  console.log('se invoca el servicio crear correo', new Date(Date.now()).toLocaleString());
  const { mailer, section, subject, message, user, phone } = req.body;
  const mails: Mails = new Mails(mailer, section, subject, message, user, phone);
  if (!mails) {
    return res.json({ message: 'Error fomato correo' });
  }
  /**
   * Se realiza el envio y se guarda en base de datos
   */
  const transporter = nodemailer.createTransport({
    host: 'mail.institutodeltorax.com',
    port: 465,
    secure: true,
    requireTLS: false,
    auth: {
      user: 'info@institutodeltorax.com',
      pass: 'CBNJd4RP(!dC',
    },
  });
  await transporter
    .sendMail({
      from: 'Contacto desde <info@institutodeltorax.com>',
      to: 'info@institutodeltorax.com',
      subject: `[${mails.getSection()}] ${mails.getSubject()}`,
      html: `<p>Sección: ${mails.getSection()}</p>
                <p>Nombre: ${mails.getUser()}</p>
                <p>Correo: ${mails.getMailer()}</p>
                <p>Teléfono: ${mails.getPhone()}</p>
                <p>Mensaje: ${mails.getMessage()}</p>`,
    })
    .then(async (info) => {
      await connection.query(
        'INSERT INTO mails SET ?,?',
        [mails, { state: 1, error: info.response }],
        function (err, result, fields) {
          if (err) {
            res.json(err);
          }
          res.json({ message: 'email enviado con éxito' });
        }
      );
    })
    .catch(async (error) => {
      await connection.query(
        'INSERT INTO mails SET ?,?',
        [mails, { state: 0, error: error }],
        function (err, result, fields) {
          if (err) {
            res.json(err);
          }
          res.json({ message: `se presento error en el envio` });
        }
      );
    });
};
